<ng-container *transloco="let t">
  <form
    #registrationFormHTMLElement
    novalidate
    id="kc-form-registration"
    name="kc-form-registration"
    method="POST"
    onsubmit="submit()"
    (paste)="onPasteValidate()"
    [formGroup]="registerForm"
    [action]="registrationAction">
    <mat-card
      appearance="outlined"
      class="default-card">
      <mat-card-header>
        <mat-card-title>
          <h1>{{t('registration.titel')}}</h1>
        </mat-card-title>
      </mat-card-header>
      <span class="hint">{{t('registration.hint')}}</span>
      <mat-card-content>
        <div class="row">
          <div class="col">
            <mat-form-field class="full-width-form">
              <input
                matInput
                [placeholder]="t('registration.first_name')"
                formControlName="firstName"
                name="firstName"
                autocomplete="given-name">
              <mat-error *ngIf="firstName.hasError('required')">
                {{t('registration.first_name')}}{{t('login.required')}}
              </mat-error>
              <mat-error *ngIf="firstName.hasError('maxlength')">
                {{t('registration.max_form_length',{maxLength:MAX_FORM_LENGTH})}}
              </mat-error>
            </mat-form-field>
          </div>
        </div>
        <div class="row">
          <div class="col">
            <mat-form-field class="full-width-form">
              <input
                matInput
                [placeholder]="t('registration.last_name')"
                formControlName="lastName"
                name="lastName"
                autocomplete="family-name">
              <mat-error *ngIf="lastName.hasError('required')">
                {{t('registration.last_name')}}{{t('login.required')}}
              </mat-error>
              <mat-error *ngIf="lastName.hasError('maxlength')">
                {{t('registration.max_form_length',{maxLength:MAX_FORM_LENGTH})}}
              </mat-error>
            </mat-form-field>
          </div>
        </div>
        <div class="row">
          <div class="col">
            <mat-form-field class="full-width-form">
              <input
                matInput
                [placeholder]="t('registration.email')"
                formControlName="email"
                name="email"
                autocomplete="email">
              <mat-error *ngIf="email.hasError('required')">
                {{t('registration.email')}}{{t('login.required')}}
              </mat-error>
              <mat-error *ngIf="email.hasError('email')">{{t('registration.invalid_email')}}</mat-error>
              <mat-error *ngIf="email.hasError('maxlength')">
                {{t('registration.max_form_length',{maxLength:MAX_FORM_LENGTH})}}
              </mat-error>
            </mat-form-field>
          </div>
        </div>
        <div class="row long-hint">
          <div class="col">
            <mat-form-field class="full-width-form">
              <input
                matInput
                [placeholder]="t('registration.password')"
                formControlName="password"
                name="password"
                type="password"
                autocomplete="new-password">
              <mat-hint>
                <app-secure-password-hint [errors]="passwordStrengthErrors"></app-secure-password-hint>
              </mat-hint>
              <mat-error>
                <app-secure-password-hint [errors]="passwordStrengthErrors"></app-secure-password-hint>
              </mat-error>
              <mat-error *ngIf="password.hasError('maxlength')">
                {{t('registration.max_form_length',{maxLength:MAX_PASSWORD_LENGTH})}}
              </mat-error>
              <mat-error *ngIf="passwordMatchesEmailError">
                {{t('password_validation.dont_match_email')}}
              </mat-error>
            </mat-form-field>
          </div>
        </div>
        <div class="row long">
          <div class="col">
            <mat-form-field class="full-width-form">
              <input
                matInput
                [placeholder]="t('registration.repeat_password')"
                formControlName="passwordConfirm"
                name="password-confirm"
                type="password"
                autocomplete="new-password">
              <mat-error *ngIf="passwordConfirm.hasError('required')">
                {{t('registration.password')}} {{t('registration.confirm')}} {{t('login.required')}}
              </mat-error>
              <mat-error *ngIf="passwordMatchError">{{t('password_validation.dont_match')}}</mat-error>
              <mat-error *ngIf="passwordConfirm.hasError('maxlength')">
                {{t('registration.max_form_length',{maxLength:MAX_PASSWORD_LENGTH})}}
              </mat-error>
            </mat-form-field>
          </div>
        </div>
        <div class="row inline">
          <div class="col">
            <mat-checkbox
              color="primary"
              formControlName="tos">
              {{t('registration.accept')}}
              <a
                href="#"
                (click)="openDialog({type:'tos'})"
                (auxclick)="$event.preventDefault()">
                {{t('registration.tos')}}
              </a>
            </mat-checkbox>
          </div>
        </div>
        <div class="row inline">
          <div class="col">
            <mat-checkbox
              color="primary"
              formControlName="privacy">
              {{t('registration.consent')}}
              <a
                href="#"
                (click)="openDialog({type:'privacy'})"
                (auxclick)="$event.preventDefault()">
                {{t('registration.privacy')}}
              </a>
            </mat-checkbox>
          </div>
        </div>
      </mat-card-content>
      <mat-card-actions
        align="end"
        class="actions default-card-actions-padding">
        <button
          mat-raised-button
          [disabled]="!this.registerForm.valid"
          color="primary"
          type="submit">
          {{t('registration.titel')}}
        </button>
      </mat-card-actions>
    </mat-card>
  </form>
  <mat-card
    appearance="outlined"
    class="default-card">
    <mat-card-content>
      <span>{{t('registration.login_hint')}}</span>
      <a
        color="accent"
        [href]="loginUrl">
        {{t('registration.login_here')}}
      </a>
    </mat-card-content>
  </mat-card>
</ng-container>
